'1205VU-Meter4-3dBx.bas fr pong mit Bascom-demo-2.0.7.1, ca.2kB, von Heinz D.
'
'logarithmisch, 3dB pro Zeile, 2 Spalten, fr Mischpulte
'
'Ui, Integral durch einsammeln von 128 Werten, Ueff=Ui*1,11
'
'Uref=5V
'
'10 LED = 202 = 1,095Veff (sinus) =+3dB
'
'linker Kanal 1 adc7
'linker Kanal 2 adc6
'rechter Kanal 2 adc5
'rechter Kanal 1 adc4
'
'jeder Kanal erhlt einen Schutzwiderstand in Reihe von 22k
'
'die Anzeige steht auf dem Kopf !!!
'-------------------------------------------------------------
$crystal = 8000000                                          'keine Fuse verndert
$regfile = "m8def.dat"
$hwstack = 32
$swstack = 32
$framesize = 32
'-------------------------------------------------------------
Dim Pongfeld(12) As Word                                    'Feld
Dim Pongspal As Byte                                        'Spaltenzhler
Dim Pongcout As Byte                                        'temp
Dim Pongdout As Byte                                        'temp

Config Portb = 31                                           '&b00011111
Config Portc = 15                                           '&b00001111
Config Portd = 240                                          '&b11110000

Config Timer2 = Timer , Prescale = 32                       'Alarmzeit abgeleitet:!!!
On Ovf2 T2interrupt                                         'Timer2=LED-Bildschirm
Enable Timer2 :
Start Timer2 :
Enable Interrupts
'-------------------------------------------------------------
Config Adc = Single , Prescaler = Auto

Dim Adcwert(4) As Word                                      '4 Balken
Dim Adctemp(4) As Word

Dim Alarmzeit As Word                                       '3s

Dim I As Byte                                               'Index
Dim J As Byte
Dim K As Byte
'=============================================================
Do
   For K = 1 To 127                                         'integrieren
   For I = 1 To 4                                           '4 Kanle
      J = I + 3                                             'fr getadc(4-7)
      Adctemp(i) = Adctemp(i) + Getadc(j)
   Next I
   Next K

   For I = 1 To 4                                           '4 Kanle
      J = I * 3 : J = J - 1                                 'fr LED-Spalte

      Adctemp(i) = Adctemp(i) / 64                          'U neu
      If Adctemp(i) > 285 Then Alarmzeit = 3000             '286=Clipping ?

      Adcwert(i) = Adcwert(i) + Adctemp(i)                  'U alt + U neu
      Adcwert(i) = Adcwert(i) / 2                           'geteilt durch 2

      If Adcwert(i) < 9 Then Pongfeld(j) = 0                '3dB-Balken bilden + anzeigen
      If Adcwert(i) > 8 Then Pongfeld(j) = 1
      If Adcwert(i) > 12 Then Pongfeld(j) = 3
      If Adcwert(i) > 17 Then Pongfeld(j) = 7
      If Adcwert(i) > 24 Then Pongfeld(j) = 15
      If Adcwert(i) > 35 Then Pongfeld(j) = 31
      If Adcwert(i) > 50 Then Pongfeld(j) = 63
      If Adcwert(i) > 70 Then Pongfeld(j) = 127
      If Adcwert(i) > 100 Then Pongfeld(j) = 255
      If Adcwert(i) > 142 Then Pongfeld(j) = 511            '143 = 775mVeff = 0dB
      If Adcwert(i) > 201 Then Pongfeld(j) = 1023           'aufrunden
   Next I

      Pongfeld(1) = Pongfeld(2) Or 513                      '2.Spalte+Eckpunkte einblenden
      Pongfeld(3) = 0
      Pongfeld(4) = Pongfeld(5)                             '2.Spalte
      Pongfeld(6) = 0
      Pongfeld(7) = 0
      Pongfeld(9) = Pongfeld(8)                             '2.Spalte
      Pongfeld(10) = 0
      Pongfeld(12) = Pongfeld(11) Or 513                    '2.Spalte+Eckpunkte einblenden

   If Alarmzeit > 0 Then
      For I = 2 To 11 :
         Pongfeld(i) = Pongfeld(i) Or 512 :                 'Alarm-Balken einblenden
      Next I
   End If

Loop
'====================================================================
'Die Routine wird bei Prescale=32 alle 1,024ms aktiv = 81 Bilder/s
'====================================================================
T2interrupt:

If Alarmzeit > 0 Then Decr Alarmzeit                        '3s
'------------------------------------------------------------
Portb = Portb And &B11111100                                'alle LED lschen,
Portc = Portc And &B11110000                                'ohne andere Port
Portd = Portd And &B00001111                                'zu beeinflussen

'immer eine Spalte anzeigen =================================
Incr Pongspal                                               'Feld anzeigen
If Pongspal = 13 Then                                       'Spalte 1 ?
   Pongspal = 1
   Portb.4 = 0                                              '4094 data
Else                                                        'Spalte 2-12 ?
   Portb.4 = 1                                              '4094 data
End If
Portb.3 = 1 : Portb.3 = 0                                   '4094 clk
Portb.2 = 1                                                 '4094 strobe

Pongcout = High(pongfeld(pongspal)) And &B00000011          'vorbereiten
Portb = Portb Or Pongcout                                   'anzeigen

Pongdout = Low(pongfeld(pongspal))                          'vorbereiten
Pongcout = Pongdout And &B00001111
Portc = Portc Or Pongcout                                   'anzeigen

Pongdout = Pongdout And &B11110000                          'vorbereiten
Portd = Portd Or Pongdout                                   'anzeigen

T2i_end:
Return
End